'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _chart = require('../../../../node_modules/lib-ibos/lib/ibos/chart');

var _chart2 = _interopRequireDefault(_chart);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Chart = function (_Component) {
    (0, _inherits3.default)(Chart, _Component);

    function Chart(props) {
        (0, _classCallCheck3.default)(this, Chart);
        return (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props));
    }

    Chart.prototype.render = function render() {
        var _props = this.props,
            element = _props.element,
            displayName = _props.displayName,
            children = _props.children,
            others = (0, _objectWithoutProperties3.default)(_props, ['element', 'displayName', 'children']);

        var eleList = element ? element.list : [];
        if (!eleList || eleList.length == 0) {
            return _react2.default.createElement('noscript', null);
        }
        var dataSource = [];
        //判断数据权限
        eleList.map(function (ele) {
            var obj = {};
            for (var name in ele) {
                var eleSec = ele[name].security;
                if (eleSec && eleSec.indexOf("r") > -1) {
                    obj[name] = {
                        security: ele[name].security,
                        value: ele[name].value
                    };
                }
            }
            dataSource.push(obj);
        });
        var xAxis = "";
        var chartChildren = [];
        //把children中的displayName换成name属性
        children.map(function (child) {
            if (child.type.displayName == "XAxis") {
                xAxis = child.props.dataIndex;
            }
            var props = child.props,
                otherProps = (0, _objectWithoutProperties3.default)(child, ['props']);
            var displayName = props.displayName,
                rest = (0, _objectWithoutProperties3.default)(props, ['displayName']);

            chartChildren.push((0, _extends3.default)({
                props: (0, _extends3.default)({
                    name: displayName
                }, rest)
            }, otherProps));
        });
        var chartProps = (0, _extends3.default)({
            // dataSource,
            //TODO 潮哥说先不要判断权限，要判断权限的时候把下面一行注释掉上面一行的注释去掉就行了
            dataSource: eleList,
            xAxis: xAxis,
            children: chartChildren,
            title: displayName
        }, others);
        return _react2.default.createElement(_chart2.default, chartProps);
    };

    return Chart;
}(_react.Component);

Chart.Serie = _chart2.default.Serie;
Chart.XAxis = _chart2.default.XAxis;

exports.default = Chart;
module.exports = exports['default'];