'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _select = require('../../../../node_modules/lib-ibos/lib/antd/select');

var _select2 = _interopRequireDefault(_select);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _formLayout = require('../../../../node_modules/lib-ibos/lib/ibos/form-layout');

var _formLayout2 = _interopRequireDefault(_formLayout);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormItem = _formLayout2.default.FormItem;

var Select = (_temp = _class = function (_Component) {
    (0, _inherits3.default)(Select, _Component);

    function Select(props) {
        (0, _classCallCheck3.default)(this, Select);
        return (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props));
    }

    Select.prototype.render = function render() {
        var _props = this.props,
            displayName = _props.displayName,
            element = _props.element,
            inputSize = _props.inputSize,
            labelWidth = _props.labelWidth,
            otherProps = (0, _objectWithoutProperties3.default)(_props, ['displayName', 'element', 'inputSize', 'labelWidth']);

        var options = element ? element.option : {};
        var selectOption = [];
        if (options) {
            for (var name in options) {
                var option = options[name];
                //适应ibos服务端的两种数据结构
                if ((typeof option === 'undefined' ? 'undefined' : (0, _typeof3.default)(option)) == "object") {
                    var optionProps = { key: option.itemId };
                    selectOption.push(_react2.default.createElement(
                        _select2.default.Option,
                        optionProps,
                        option.itemValue
                    ));
                } else if (typeof option == "string") {
                    var _optionProps = { key: option };
                    selectOption.push(_react2.default.createElement(
                        _select2.default.Option,
                        _optionProps,
                        option
                    ));
                }
            }
        }
        var selectProps = (0, _extends3.default)({
            size: inputSize ? inputSize : "small",
            value: element ? element.value + "" : ""
        }, otherProps);
        var formProps = {
            security: element ? element.security ? element.security : "r" : "r",
            label: displayName,
            labelWidth: labelWidth
        };
        return _react2.default.createElement(
            FormItem,
            formProps,
            _react2.default.createElement(
                _select2.default,
                selectProps,
                selectOption
            )
        );
    };

    return Select;
}(_react.Component), _class.Option = _select2.default.Option, _class.OptGroup = _select2.default.OptGroup, _temp);
exports.default = Select;
module.exports = exports['default'];