"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _steps = require("../../../../node_modules/lib-ibos/lib/ibos/steps");

var _steps2 = _interopRequireDefault(_steps);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Steps = function (_Component) {
    (0, _inherits3.default)(Steps, _Component);

    function Steps(props) {
        (0, _classCallCheck3.default)(this, Steps);
        return (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props));
    }

    Steps.prototype.render = function render() {
        var _props = this.props,
            children = _props.children,
            stepStatus = _props.stepStatus,
            element = _props.element,
            otherProps = (0, _objectWithoutProperties3.default)(_props, ["children", "stepStatus", "element"]);

        if (!element || !element.list || element.list.length == 0) {
            return _react2.default.createElement("noscript", null);
        }
        var child = children[0] || children;
        var _child$props = child.props,
            dataIndex = _child$props.dataIndex,
            statusIndex = _child$props.statusIndex,
            stepProps = (0, _objectWithoutProperties3.default)(_child$props, ["dataIndex", "statusIndex"]);

        var stepKey = 0;
        return _react2.default.createElement(
            _steps2.default,
            otherProps,
            element.list.map(function (e) {
                stepKey++;
                var thisStepStatus = e[dataIndex].value;
                var mainStepStatus = void 0;
                if (typeof statusIndex == "string") {
                    mainStepStatus = element[statusIndex];
                } else if ((typeof statusIndex === "undefined" ? "undefined" : (0, _typeof3.default)(statusIndex)) == "object") {
                    mainStepStatus = statusIndex.value;
                } else if (typeof statusIndex == "function") {
                    mainStepStatus = statusIndex();
                }

                var status = stepStatus ? stepStatus(parseInt(thisStepStatus), parseInt(mainStepStatus)) : thisStepStatus;
                var stepChildren = child.props.children;
                var leftObjList = [];
                var rightObjList = [];
                var description = void 0;
                if (stepChildren) {
                    stepChildren.map(function (stepChild) {
                        if (stepChild.type() == "leftside") {
                            leftObjList.push(stepChild.props.children || e[stepChild.props.dataIndex].value || "");
                        } else if (stepChild.type() == "rightside") {
                            if (stepChild.props.children) {
                                var RSideChildren = stepChild.props.children;
                                //单个多个children分开处理是因为，单个的时候children是个object，不是arr，不能用.map
                                if (RSideChildren.length > 0) {
                                    //多个children
                                    RSideChildren.map(function (obj) {
                                        var props = obj.props,
                                            restObj = (0, _objectWithoutProperties3.default)(obj, ["props"]);
                                        var element = props.element,
                                            onClick = props.onClick,
                                            restProps = (0, _objectWithoutProperties3.default)(props, ["element", "onClick"]);

                                        if (typeof element == "string") {
                                            element = e[element];
                                        }
                                        if (element.security.indexOf("r") > -1) {
                                            var rightObjProps = (0, _extends3.default)({ element: element }, restProps);
                                            if (onClick) {
                                                var thisClick = onClick();
                                                rightObjProps.onClick = function () {
                                                    return thisClick(element);
                                                };
                                            }
                                            rightObjProps.id = stepKey;
                                            rightObjList.push((0, _extends3.default)({
                                                props: rightObjProps
                                            }, restObj));
                                        }
                                    });
                                } else {
                                    //单个
                                    var props = RSideChildren.props,
                                        restObj = (0, _objectWithoutProperties3.default)(RSideChildren, ["props"]);
                                    var _element = props.element,
                                        onClick = props.onClick,
                                        restProps = (0, _objectWithoutProperties3.default)(props, ["element", "onClick"]);

                                    if (typeof _element == "string") {
                                        _element = e[_element];
                                    }
                                    if (_element.security.indexOf("r") > -1) {
                                        var rightObjProps = (0, _extends3.default)({ element: _element }, restProps);
                                        if (onClick) {
                                            var thisClick = onClick();
                                            rightObjProps.onClick = function () {
                                                return thisClick(_element);
                                            };
                                        }
                                        rightObjProps.id = stepKey;
                                        rightObjList.push((0, _extends3.default)({
                                            props: rightObjProps
                                        }, restObj));
                                    }
                                }
                            } else {
                                rightObjList.push(e[stepChild.props.dataIndex].value || "");
                            }
                        }
                    });
                    var left = _react2.default.createElement(
                        _steps2.default.SideStep,
                        null,
                        leftObjList.map(function (obj) {
                            if (obj) {
                                return _react2.default.createElement(
                                    "div",
                                    null,
                                    obj,
                                    _react2.default.createElement("br", null)
                                );
                            }
                        })
                    );
                    var right = _react2.default.createElement(
                        "div",
                        null,
                        rightObjList.map(function (obj) {
                            if (obj) {
                                return obj;
                            }
                        })
                    );
                    description = _react2.default.createElement(
                        "div",
                        null,
                        left,
                        right
                    );
                }

                var StepsStepProps = (0, _extends3.default)({
                    status: status,
                    key: stepKey,
                    description: description
                }, stepProps);
                return _react2.default.createElement(_steps2.default.Step, StepsStepProps);
            })
        );
    };

    return Steps;
}(_react.Component);

Steps.LSideStep = function () {
    return "leftside";
};
Steps.RSideStep = function () {
    return "rightside";
};
Steps.Step = _steps2.default.Step;
exports.default = Steps;
module.exports = exports["default"];