'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _table = require('../../../../node_modules/lib-ibos/lib/ibos/table');

var _table2 = _interopRequireDefault(_table);

var _button = require('../button');

var _button2 = _interopRequireDefault(_button);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _request = require('../util/request');

var _request2 = _interopRequireDefault(_request);

require('./style.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Table = function (_Component) {
    (0, _inherits3.default)(Table, _Component);

    function Table(props) {
        (0, _classCallCheck3.default)(this, Table);

        var _this = (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props));

        _this.onElementChange = function (element) {
            _this.setState({ element: element });
        };

        _this.state = {};
        return _this;
    }

    Table.prototype.render = function render() {
        var _props = this.props,
            children = _props.children,
            elementName = _props.elementName,
            hasCheckbox = _props.hasCheckbox,
            onCustomChange = _props.onCustomChange,
            addRow = _props.addRow,
            deleteRow = _props.deleteRow,
            customConfig = _props.customConfig,
            otherProps = (0, _objectWithoutProperties3.default)(_props, ['children', 'elementName', 'hasCheckbox', 'onCustomChange', 'addRow', 'deleteRow', 'customConfig']);

        var element = this.state.element || this.props.element;
        var tableCols = [];
        var expand = void 0;
        var expandDataIndex = void 0;
        var expandDataValue = void 0;
        var eleList = element ? 'list' in element ? element.list : [] : [];
        var security = element ? 'security' in element ? element.security : "" : "";
        children.map(function (child) {
            if (child.type()) {
                expandDataIndex = child.props.dataIndex;
                expandDataValue = child.props.dataValue;
                expand = child.props.children;
            } else {
                var props = child.props,
                    otherChildProps = (0, _objectWithoutProperties3.default)(child, ['props']);
                var displayName = props.displayName,
                    _children = props.children,
                    restProps = (0, _objectWithoutProperties3.default)(props, ['displayName', 'children']);

                var tableColProps = (0, _extends3.default)({}, restProps, {
                    title: displayName
                });
                if (_children) {
                    tableColProps.render = function (text, record, index) {
                        var childList = [];
                        if (!_children.length) {
                            childList.push(_children);
                        } else {
                            childList = _children;
                        }
                        return childList.map(function (child) {
                            var props = child.props,
                                r = (0, _objectWithoutProperties3.default)(child, ['props']);
                            var element = props.element,
                                _onChange = props.onChange,
                                o = (0, _objectWithoutProperties3.default)(props, ['element', 'onChange']);

                            if (!element && text) {
                                element = {
                                    value: text
                                };
                            } else if (typeof element == "string") {
                                element = eleList[index][element];
                            }
                            return (0, _extends3.default)({
                                props: (0, _extends3.default)({
                                    element: element,
                                    onChange: function onChange(data1, data2) {
                                        return _onChange(index, data1, data2);
                                    }
                                }, o)
                            }, r);
                        });
                    };
                }
                tableCols.push((0, _extends3.default)({
                    props: tableColProps
                }, otherChildProps));
            }
        });

        var data = [];
        var eleKey = 0;
        eleList.map(function (ele) {
            var obj = {};
            eleKey++;
            obj["key"] = eleKey + "";
            for (var name in ele) {
                var eleSec = ele[name].security;
                if (eleSec && eleSec.indexOf("r") > -1) {
                    obj[name] = ele[name].value;
                }
            }
            data.push(obj);
        });
        var pageInfo = element ? element.pageInfo : {};
        var tableProps = (0, _extends3.default)({}, otherProps, {
            size: "small",
            //TODO 暂时写死，lib-ibos中定的，如果没有这个参数的话第一列会被吃掉
            showSeq: true,
            dataSource: data,
            // pagination : element?element.pageInfo:{},
            //TODO customConfig暂时不丢进去，自定义列功能未做，丢进去的话会导致分页没反应。主要原因在lib-ibos中
            // customConfig:element?element.customization:{},
            children: tableCols
        });
        if (pageInfo && pageInfo.pagingEnabled) {
            var pagingSize = pageInfo.pagingSize,
                totalRows = pageInfo.totalRows,
                pagingUrl = pageInfo.pagingUrl,
                currentPageNumber = pageInfo.currentPageNumber,
                otherPageInfo = (0, _objectWithoutProperties3.default)(pageInfo, ['pagingSize', 'totalRows', 'pagingUrl', 'currentPageNumber']);

            tableProps.pagination = (0, _extends3.default)({
                pageSize: pagingSize,
                total: totalRows,
                current: currentPageNumber + 1,
                onElementChange: this.onElementChange,
                onChange: function onChange(current) {
                    var _this2 = this;

                    if (pagingUrl) {
                        var url = pagingUrl.substring(0, pagingUrl.indexOf("paging"));
                        url += "paging=" + (current - 1);
                        (0, _request2.default)(url + "&returnJson=data", {
                            // body:querystring.stringify(body),
                            method: "post"
                        }).then(function (data) {
                            var element = data.element[elementName];
                            _this2.onElementChange(element);
                        });
                    }
                }
            }, otherPageInfo);
            tableProps.onChange = function (pagination, filters, sorter) {};
        } else {
            tableProps.pagination = false;
        }
        if (typeof hasCheckbox == "string" && hasCheckbox == "true" || typeof hasCheckbox == "boolean" && hasCheckbox) {
            tableProps.rowSelection = {
                onChange: onCustomChange
            };
        }
        if (expand) {
            tableProps.expandedRowRender = function (record) {
                var index = parseInt(record.key) - 1;
                var dataUrl = void 0;
                if (expandDataIndex && expandDataValue) {
                    var o = eleList[index];
                    var e = o[expandDataIndex];
                    dataUrl = e[expandDataValue];
                    var _expand = expand,
                        props = _expand.props,
                        expandOthers = (0, _objectWithoutProperties3.default)(_expand, ['props']);

                    return (0, _extends3.default)({
                        props: {
                            dataUrl: dataUrl,
                            props: props
                        }
                    }, expandOthers);
                } else {
                    return expand;
                }
            };
        }
        var exportUrl = element ? element.exportUrl : "";
        var tableTitle = function tableTitle() {
            var exprotButton = _react2.default.createElement('noscript', null);
            var addRowButton = _react2.default.createElement('noscript', null);
            var deleteRowButton = _react2.default.createElement('noscript', null);

            if (exportUrl) {
                exprotButton = _react2.default.createElement(_button2.default, { displayName: '\u5BFC\u51FA', size: 'small', onClick: function onClick() {
                        window.open(exportUrl, "Export");
                    } });
            }

            if (security.indexOf("c") > -1) {
                addRowButton = _react2.default.createElement(_button2.default, { displayName: '\u65B0\u589E', size: 'small', onClick: function onClick() {
                        addRow();
                    } });
            }

            if (security.indexOf("d") > -1) {
                deleteRowButton = _react2.default.createElement(_button2.default, { displayName: '\u5220\u9664', size: 'small', onClick: function onClick() {
                        deleteRow();
                    } });
            }
            return _react2.default.createElement(
                'div',
                null,
                addRowButton,
                deleteRowButton,
                exprotButton
            );
        };
        tableProps.title = tableTitle;
        return _react2.default.createElement(_table2.default, tableProps);
    };

    return Table;
}(_react.Component);

Table.Col = _table2.default.Col;
Table.Expand = function () {
    return "Expand";
};
exports.default = Table;
module.exports = exports['default'];