'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _upload = require('../../../../node_modules/lib-ibos/lib/ibos/upload');

var _upload2 = _interopRequireDefault(_upload);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _formLayout = require('../../../../node_modules/lib-ibos/lib/ibos/form-layout');

var _formLayout2 = _interopRequireDefault(_formLayout);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _request = require('../util/request');

var _request2 = _interopRequireDefault(_request);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormItem = _formLayout2.default.FormItem;

var Upload = (_temp = _class = function (_Component) {
    (0, _inherits3.default)(Upload, _Component);

    function Upload(props) {
        (0, _classCallCheck3.default)(this, Upload);

        var _this = (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props));

        _this.parseResponse = function (xml, file) {
            //console.log(xml);

            var re = /clientFileName="(.*?)"/gi;
            var arr = re.exec(xml);
            if (arr) {
                file.name = arr[1];
            }

            re = /fileUrl="(.*?)"/gi;
            arr = re.exec(xml);
            if (arr) {
                file.url = arr[1];
            }
        };

        _this.replaceElementName = function (xml) {
            //let re = /name="(.*?)"/gi;
            //let arr = re.exec(xml);

            xml = xml.replace(/name="file"/gi, "name=\"" + _this.props.element.name || _this.props.elementName + "\"");
            //console.log(xml);
            return xml;
        };

        _this.handleChange = function (info) {
            var fileList = info.fileList;
            var uploadState = false; // 上传成功标志

            fileList = fileList.slice(-1);

            // 2. 读取远程路径并显示链接
            fileList = fileList.map(function (file) {
                if (file.response) {
                    _this.parseResponse(file.response, file);
                    _this.props.onChange(_this.replaceElementName(file.response));
                }
                return file;
            });

            // 3. 按照服务器返回信息筛选成功上传的文件
            fileList = fileList.filter(function (file) {
                if (file.response) {
                    uploadState = true;
                    //return file.response.status === 'success';
                }
                return true;
            });

            if (!uploadState) {
                _this.setState({ fileList: fileList });
            }
        };

        _this.handleRemove = function (file) {
            _this.props.onChange("");
        };

        _this.handleBeforeUpload = function (file) {

            //判断文件大小
            if (_this.props.maxSize > 0) {
                if (file.size > _this.props.maxSize * 1024 * 1024) {
                    message.error("上传文件超过 " + _this.props.maxSize + "M");
                    return false;
                }
            }

            //判断后缀合法性
            if (_this.props.accept) {
                //文件后缀
                var type = /\.[^\.]+$/.exec(file.name);

                if (_this.props.accept.indexOf(type[0]) == -1) {
                    message.error("上传文件类型不在 " + _this.props.accept + " 内");
                    return false;
                }
            }

            return true;
            //this.state.fileList = [];
        };

        _this.handlePreview = function (file) {
            if (_this.props.downLoadUrl) {
                (0, _request2.default)(_this.props.downLoadUrl + '&fileUrl=' + file.url + '&clientFileName=' + file.name).then(function (data) {

                    //console.log("download",data);
                    var iframe = document.getElementById("download");
                    //console.log(iframe);

                    iframe.src = data;
                    //form.action = data;
                    //form.submit()
                });
                return false;
            }
            return true;
        };

        _this.state = {
            fileList: []
        };
        return _this;
    }

    Upload.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
        if (nextProps.element && nextProps.element.value) {
            var file = { uid: -1, status: 'done' };
            this.parseResponse(nextProps.element.value, file);
            if (file.name && file.url) {
                this.state.fileList = [file];
            } else {
                this.state.fileList = [];
            }

            //console.log(this.state.fileList);
        } else {
            this.state.fileList = [];
        }
    };

    //正常上传得到xml，需要从中得到 url 和 name


    Upload.prototype.render = function render() {
        //console.log("render",this.state.fileList)
        //TODO 上传的地址在常量中维护
        //console.log(this.state,this.props);
        var read = this.props.element && this.props.element.security && this.props.element.security.indexOf("r") > -1;
        var update = this.props.element && this.props.element.security && this.props.element.security.indexOf("u") > -1;
        var formProps = {
            security: this.props.element ? this.props.element.security ? this.props.element.security : "r" : "r",
            label: this.props.displayName
        };

        return _react2.default.createElement(
            FormItem,
            formProps,
            _react2.default.createElement(
                _upload2.default,
                {
                    disabled: !update,
                    action: this.props.upLoadUrl,
                    onRemove: this.handleRemove,
                    onChange: this.handleChange,
                    beforeUpload: this.handleBeforeUpload,
                    onPreview: this.handlePreview,
                    fileList: this.state.fileList },
                '\u4EC5\u9650\u4E0A\u4F20 ',
                this.props.accept,
                ' \u7B49\u6587\u4EF6\uFF0C\u4E14\u5C0F\u4E8E ',
                this.props.maxSize,
                'M \u7684\u6587\u4EF6'
            )
        );
    };

    return Upload;
}(_react.Component), _class.defaultProps = {
    onChange: function onChange(value) {},
    element: {
        security: "r"
    },
    maxSize: 2,
    accept: "*.txt, *.doc, *.docx, *.xls, *.xlsx, *.pdf, *.jpg, *.jpeg, *.gif, *.png, *.bmp"
}, _temp);
exports.default = Upload;
module.exports = exports['default'];