"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

exports.default = request;

require("fetch-detector");

require("fetch-ie8");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//import Promise from 'promise-polyfill';

// To add to window
// if (!window.Promise) {
//     window.Promise = Promise;
// }

//TODO 暂时放在这里

var rquery = /\?/;

function parseJSON(response) {
    return response.json();
}

function checkStatus(response) {
    if (response.status >= 200 && response.status < 300) {
        return response;
    }

    checkDcas(response);

    var error = new Error(response.statusText);
    error.response = response;
    throw error;
}

function checkErrCode(json) {
    if (json.resultCode == 420) {
        goToLogin(json);
    } else {
        return json;
    }
}

function goToLogin(json) {
    var dcasStateValiURL = json.dcasStateValiURL,
        backurl = json.backurl;

    backurl = location.protocol + "//" + location.host + "/login.html";
    // 添加backurl
    if (top.base64) {
        backurl += (rquery.test(backurl) ? '&' : '?') + "target=" + top.base64.encodeUrlsafe(location.href);
        dcasStateValiURL += (rquery.test(dcasStateValiURL) ? '&' : '?') + "backurl=" + top.base64.encodeUrlsafe(backurl);
    }
    // 直接跳转到dcas验证
    top.location.href = dcasStateValiURL;
}
/**
 * 检查并处理 dcas 420错误
 * @param response
 */
function checkDcas(response) {

    if (response.status === 420) {
        response.text().then(function (info) {
            var jsonData = new Function("return " + info)();
            goToLogin(jsonData);
        });
    }
}

/**
 * Requests a URL, returning a promise.
 *
 * @param  {string} url       The URL we want to request
 * @param  {object} [options] The options we want to pass to "fetch"
 * @return {object}           An object containing either "data" or "err"
 */
function request(url) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var headers = options.headers,
        other = (0, _objectWithoutProperties3.default)(options, ["headers"]);

    var opts = (0, _extends3.default)({
        mode: 'cors', // 支持跨域
        credentials: 'include', // 带cookie,
        headers: (0, _extends3.default)({
            'X-Requested-With': 'XMLHttpRequest', // ajax标识
            'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8' }, headers)
    }, other);
    return fetch(url, opts).then(checkStatus).then(parseJSON).then(checkErrCode).then(function (data) {
        return data;
    }).catch(function (err) {
        return err;
    });
}
module.exports = exports["default"];